from gcs_cli.commands.storage_gateway.update.activescale import activescale_update
from gcs_cli.commands.storage_gateway.update.azure_blob import azure_blob_update
from gcs_cli.commands.storage_gateway.update.blackpearl import blackpearl_update
from gcs_cli.commands.storage_gateway.update.box import box_update
from gcs_cli.commands.storage_gateway.update.ceph import ceph_update
from gcs_cli.commands.storage_gateway.update.dropbox import dropbox_update
from gcs_cli.commands.storage_gateway.update.google_cloud_storage import (
    google_cloud_storage_update,
)
from gcs_cli.commands.storage_gateway.update.google_drive import google_drive_update
from gcs_cli.commands.storage_gateway.update.hpss import hpss_update
from gcs_cli.commands.storage_gateway.update.irods import irods_update
from gcs_cli.commands.storage_gateway.update.onedrive import onedrive_update
from gcs_cli.commands.storage_gateway.update.posix import posix_update
from gcs_cli.commands.storage_gateway.update.posix_staging import posix_staging_update
from gcs_cli.commands.storage_gateway.update.s3 import s3_update
from gcs_cli.parsing import globus_group


@globus_group(name="update")
def update_command() -> None:
    """Update an existing Storage Gateway"""


update_command.add_command(azure_blob_update)
update_command.add_command(blackpearl_update)
update_command.add_command(ceph_update)
update_command.add_command(dropbox_update)
update_command.add_command(google_cloud_storage_update)
update_command.add_command(google_drive_update)
update_command.add_command(onedrive_update)
update_command.add_command(box_update)
update_command.add_command(posix_update)
update_command.add_command(posix_staging_update)
update_command.add_command(s3_update)
update_command.add_command(activescale_update)
update_command.add_command(irods_update)
update_command.add_command(hpss_update)
