import marshmallow as ma

from .data_type import Schema, data_type, data_type_schema


@data_type("subscription_required#1.0.0")
class SubscriptionRequired_1_0_0(Schema):
    """
    Error details when the caller has attempted to access a feature
    not supported by the endpoint's subscription.
    """

    subscription_level = ma.fields.String(
        description="Level of subscription required for this feature"
    )

    add_ons = ma.fields.List(
        ma.fields.String,
        description="List of subscription add-ons required for this feature",
    )


SubscriptionRequired = data_type_schema.SubscriptionRequired
