"""
globus-connect-server node cleanup
"""
import click

from gcs_cli.parsing.command_decorator import globus_command


@globus_command(
    "cleanup",
    short_help="Clean up a Globus Connect Server node",
    help="Clean up a Globus Connect Server node",
    disable_options=["format", "explicit_host"],
)
@click.option("--ip-address", "-i", help="IP Address of this GCS Node")
@click.option(
    "--local-cleanup-only",
    is_flag=True,
    help="Clean up local state only. Do not attempt to remove the node from "
    "the endpoint.",
)
@click.option(
    "--root",
    hidden=True,
    type=click.Path(exists=True, file_okay=False, dir_okay=True),
    default="/",
)
@click.option("--verbose", "-v", is_flag=True)
@click.pass_context
def node_cleanup(ctx, ip_address, local_cleanup_only, root, verbose):
    from .node_cleanup import node_cleanup as nc

    nc(ctx, ip_address, local_cleanup_only, root, verbose)
