from ..service_manager import ServiceManager


class GCSManager:
    """
    Class to configure a GCS Manager service
    """

    service_name = "gcs_manager"

    def __init__(self, service_manager=None):
        if service_manager is None:
            service_manager = ServiceManager
        self.service_manager = service_manager

    def setup(self, force=False):
        self.service_manager.enable(self.service_name, socket=True)
        self.service_manager.restart(self.service_name, socket=True)

    def cleanup(self, force=False):
        self.service_manager.stop(self.service_name, socket=True)
        self.service_manager.disable(self.service_name, socket=True)
