"""add pending_updates table

Revision ID: ab11098d41d5
Revises: d0eed3bd1fa1
Create Date: 2022-06-28 16:29:06.818095

"""
from alembic import op
import sqlalchemy as sa
import globus


# revision identifiers, used by Alembic.
revision = 'ab11098d41d5'
down_revision = 'd0eed3bd1fa1'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('pending_updates',
    sa.Column('update_id', sa.INTEGER(), autoincrement=True, nullable=False),
    sa.Column('object_id', sa.TEXT(), nullable=False),
    sa.Column('change_time', globus.manager.api.models.helpers.UTCArrowType(timezone=True), nullable=False),
    sa.Column('endpoint_serial', sa.TEXT(), nullable=False),
    sa.Column('update_type', sa.Enum('DELETE', 'UPDATE_DOMAIN', 'PATCH', name='pendingupdatetype'), nullable=False),
    sa.Column('collection_serial', sa.TEXT(), nullable=True),
    sa.Column('data', sa.TEXT(), nullable=True),
    sa.ForeignKeyConstraint(['object_id'], ['configuration_object.id'], ),
    sa.PrimaryKeyConstraint('update_id')
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('pending_updates')
    # ### end Alembic commands ###
