"""Add configuration_object table

Revision ID: e2e783db064b
Revises: 028b6b104005
Create Date: 2019-08-26 21:30:34.641081

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = 'e2e783db064b'
down_revision = '028b6b104005'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('configuration_object',
    sa.Column('created_at', sa.DateTime(), nullable=False),
    sa.Column('updated_at', sa.DateTime(), nullable=False),
    sa.Column('discriminator', sa.TEXT(), nullable=True),
    sa.Column('tag', sa.Enum('ACME_ACCOUNT', 'CERTIFICATE', 'COLLECTION', 'DOMAIN', 'ENDPOINT', 'KEY_CHAIN', 'ROLE', 'STORAGE_GATEWAY', "USER_CREDENTIAL", "WILDCARD_DOMAIN", name='configurationobjecttag'), nullable=False),
    sa.Column('id', sa.TEXT(), nullable=False),
    sa.Column('serial', sa.INTEGER(), nullable=False),
    sa.Column('configuration', sa.TEXT(), nullable=False),
    sa.Column('changed', sa.BOOLEAN(), server_default='0', nullable=False),
    sa.Column('deleted', sa.BOOLEAN(), server_default='0', nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('configuration_object')
    # ### end Alembic commands ###
